# pulp_deb-client
Fetch, Upload, Organize, and Distribute Software Packages

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: v3
- Package version: 2.6.0b1.dev01595700008
- Build package: org.openapitools.codegen.languages.PythonClientCodegen
For more information, please visit [https://pulpproject.org](https://pulpproject.org)

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import pulpcore.client.pulp_deb
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import pulpcore.client.pulp_deb
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function

import time
import pulpcore.client.pulp_deb
from pulpcore.client.pulp_deb.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://pulp
# See configuration.py for a list of all supported configuration parameters.
configuration = pulpcore.client.pulp_deb.Configuration(
    host = "http://pulp"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure HTTP basic authorization: basicAuth
configuration = pulpcore.client.pulp_deb.Configuration(
    username = 'YOUR_USERNAME',
    password = 'YOUR_PASSWORD'
)

# Configure API key authorization: cookieAuth
configuration = pulpcore.client.pulp_deb.Configuration(
    host = "http://pulp",
    api_key = {
        'Session': 'YOUR_API_KEY'
    }
)
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Session'] = 'Bearer'


# Enter a context with an instance of the API client
with pulpcore.client.pulp_deb.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = pulpcore.client.pulp_deb.ContentGenericContentsApi(api_client)
    relative_path = 'relative_path_example' # str | Path where the artifact is located relative to distributions base_path
artifact = 'artifact_example' # str | Artifact file representing the physical content (optional)
file = '/path/to/file' # file | An uploaded file that may be turned into the artifact of the content unit. (optional)
repository = 'repository_example' # str | A URI of a repository the new content unit should be associated with. (optional)

    try:
        api_response = api_instance.create(relative_path, artifact=artifact, file=file, repository=repository)
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling ContentGenericContentsApi->create: %s\n" % e)
    
```

## Documentation for API Endpoints

All URIs are relative to *http://pulp*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ContentGenericContentsApi* | [**create**](docs/ContentGenericContentsApi.md#create) | **POST** /pulp/api/v3/content/deb/generic_contents/ | 
*ContentGenericContentsApi* | [**list**](docs/ContentGenericContentsApi.md#list) | **GET** /pulp/api/v3/content/deb/generic_contents/ | 
*ContentGenericContentsApi* | [**read**](docs/ContentGenericContentsApi.md#read) | **GET** {generic_content_href} | 
*ContentInstallerFileIndicesApi* | [**create**](docs/ContentInstallerFileIndicesApi.md#create) | **POST** /pulp/api/v3/content/deb/installer_file_indices/ | 
*ContentInstallerFileIndicesApi* | [**list**](docs/ContentInstallerFileIndicesApi.md#list) | **GET** /pulp/api/v3/content/deb/installer_file_indices/ | 
*ContentInstallerFileIndicesApi* | [**read**](docs/ContentInstallerFileIndicesApi.md#read) | **GET** {installer_file_index_href} | 
*ContentInstallerPackagesApi* | [**create**](docs/ContentInstallerPackagesApi.md#create) | **POST** /pulp/api/v3/content/deb/installer_packages/ | 
*ContentInstallerPackagesApi* | [**list**](docs/ContentInstallerPackagesApi.md#list) | **GET** /pulp/api/v3/content/deb/installer_packages/ | 
*ContentInstallerPackagesApi* | [**read**](docs/ContentInstallerPackagesApi.md#read) | **GET** {installer_package_href} | 
*ContentPackageIndicesApi* | [**create**](docs/ContentPackageIndicesApi.md#create) | **POST** /pulp/api/v3/content/deb/package_indices/ | 
*ContentPackageIndicesApi* | [**list**](docs/ContentPackageIndicesApi.md#list) | **GET** /pulp/api/v3/content/deb/package_indices/ | 
*ContentPackageIndicesApi* | [**read**](docs/ContentPackageIndicesApi.md#read) | **GET** {package_index_href} | 
*ContentPackageReleaseComponentsApi* | [**create**](docs/ContentPackageReleaseComponentsApi.md#create) | **POST** /pulp/api/v3/content/deb/package_release_components/ | 
*ContentPackageReleaseComponentsApi* | [**list**](docs/ContentPackageReleaseComponentsApi.md#list) | **GET** /pulp/api/v3/content/deb/package_release_components/ | 
*ContentPackageReleaseComponentsApi* | [**read**](docs/ContentPackageReleaseComponentsApi.md#read) | **GET** {package_release_component_href} | 
*ContentPackagesApi* | [**create**](docs/ContentPackagesApi.md#create) | **POST** /pulp/api/v3/content/deb/packages/ | 
*ContentPackagesApi* | [**list**](docs/ContentPackagesApi.md#list) | **GET** /pulp/api/v3/content/deb/packages/ | 
*ContentPackagesApi* | [**read**](docs/ContentPackagesApi.md#read) | **GET** {package_href} | 
*ContentReleaseArchitecturesApi* | [**create**](docs/ContentReleaseArchitecturesApi.md#create) | **POST** /pulp/api/v3/content/deb/release_architectures/ | 
*ContentReleaseArchitecturesApi* | [**list**](docs/ContentReleaseArchitecturesApi.md#list) | **GET** /pulp/api/v3/content/deb/release_architectures/ | 
*ContentReleaseArchitecturesApi* | [**read**](docs/ContentReleaseArchitecturesApi.md#read) | **GET** {release_architecture_href} | 
*ContentReleaseComponentsApi* | [**create**](docs/ContentReleaseComponentsApi.md#create) | **POST** /pulp/api/v3/content/deb/release_components/ | 
*ContentReleaseComponentsApi* | [**list**](docs/ContentReleaseComponentsApi.md#list) | **GET** /pulp/api/v3/content/deb/release_components/ | 
*ContentReleaseComponentsApi* | [**read**](docs/ContentReleaseComponentsApi.md#read) | **GET** {release_component_href} | 
*ContentReleaseFilesApi* | [**create**](docs/ContentReleaseFilesApi.md#create) | **POST** /pulp/api/v3/content/deb/release_files/ | 
*ContentReleaseFilesApi* | [**list**](docs/ContentReleaseFilesApi.md#list) | **GET** /pulp/api/v3/content/deb/release_files/ | 
*ContentReleaseFilesApi* | [**read**](docs/ContentReleaseFilesApi.md#read) | **GET** {release_file_href} | 
*ContentReleasesApi* | [**create**](docs/ContentReleasesApi.md#create) | **POST** /pulp/api/v3/content/deb/releases/ | 
*ContentReleasesApi* | [**list**](docs/ContentReleasesApi.md#list) | **GET** /pulp/api/v3/content/deb/releases/ | 
*ContentReleasesApi* | [**read**](docs/ContentReleasesApi.md#read) | **GET** {release_href} | 
*DistributionsAptApi* | [**create**](docs/DistributionsAptApi.md#create) | **POST** /pulp/api/v3/distributions/deb/apt/ | 
*DistributionsAptApi* | [**delete**](docs/DistributionsAptApi.md#delete) | **DELETE** {apt_distribution_href} | 
*DistributionsAptApi* | [**list**](docs/DistributionsAptApi.md#list) | **GET** /pulp/api/v3/distributions/deb/apt/ | 
*DistributionsAptApi* | [**partial_update**](docs/DistributionsAptApi.md#partial_update) | **PATCH** {apt_distribution_href} | 
*DistributionsAptApi* | [**read**](docs/DistributionsAptApi.md#read) | **GET** {apt_distribution_href} | 
*DistributionsAptApi* | [**update**](docs/DistributionsAptApi.md#update) | **PUT** {apt_distribution_href} | 
*PublicationsAptApi* | [**create**](docs/PublicationsAptApi.md#create) | **POST** /pulp/api/v3/publications/deb/apt/ | 
*PublicationsAptApi* | [**delete**](docs/PublicationsAptApi.md#delete) | **DELETE** {apt_publication_href} | 
*PublicationsAptApi* | [**list**](docs/PublicationsAptApi.md#list) | **GET** /pulp/api/v3/publications/deb/apt/ | 
*PublicationsAptApi* | [**read**](docs/PublicationsAptApi.md#read) | **GET** {apt_publication_href} | 
*PublicationsVerbatimApi* | [**create**](docs/PublicationsVerbatimApi.md#create) | **POST** /pulp/api/v3/publications/deb/verbatim/ | 
*PublicationsVerbatimApi* | [**delete**](docs/PublicationsVerbatimApi.md#delete) | **DELETE** {verbatim_publication_href} | 
*PublicationsVerbatimApi* | [**list**](docs/PublicationsVerbatimApi.md#list) | **GET** /pulp/api/v3/publications/deb/verbatim/ | 
*PublicationsVerbatimApi* | [**read**](docs/PublicationsVerbatimApi.md#read) | **GET** {verbatim_publication_href} | 
*RemotesAptApi* | [**create**](docs/RemotesAptApi.md#create) | **POST** /pulp/api/v3/remotes/deb/apt/ | 
*RemotesAptApi* | [**delete**](docs/RemotesAptApi.md#delete) | **DELETE** {apt_remote_href} | 
*RemotesAptApi* | [**list**](docs/RemotesAptApi.md#list) | **GET** /pulp/api/v3/remotes/deb/apt/ | 
*RemotesAptApi* | [**partial_update**](docs/RemotesAptApi.md#partial_update) | **PATCH** {apt_remote_href} | 
*RemotesAptApi* | [**read**](docs/RemotesAptApi.md#read) | **GET** {apt_remote_href} | 
*RemotesAptApi* | [**update**](docs/RemotesAptApi.md#update) | **PUT** {apt_remote_href} | 
*RepositoriesAptApi* | [**create**](docs/RepositoriesAptApi.md#create) | **POST** /pulp/api/v3/repositories/deb/apt/ | 
*RepositoriesAptApi* | [**delete**](docs/RepositoriesAptApi.md#delete) | **DELETE** {apt_repository_href} | 
*RepositoriesAptApi* | [**list**](docs/RepositoriesAptApi.md#list) | **GET** /pulp/api/v3/repositories/deb/apt/ | 
*RepositoriesAptApi* | [**modify**](docs/RepositoriesAptApi.md#modify) | **POST** {apt_repository_href}modify/ | Modify Repository Content
*RepositoriesAptApi* | [**partial_update**](docs/RepositoriesAptApi.md#partial_update) | **PATCH** {apt_repository_href} | 
*RepositoriesAptApi* | [**read**](docs/RepositoriesAptApi.md#read) | **GET** {apt_repository_href} | 
*RepositoriesAptApi* | [**sync**](docs/RepositoriesAptApi.md#sync) | **POST** {apt_repository_href}sync/ | Sync from remote
*RepositoriesAptApi* | [**update**](docs/RepositoriesAptApi.md#update) | **PUT** {apt_repository_href} | 
*RepositoriesDebVersionsApi* | [**delete**](docs/RepositoriesDebVersionsApi.md#delete) | **DELETE** {apt_repository_version_href} | 
*RepositoriesDebVersionsApi* | [**list**](docs/RepositoriesDebVersionsApi.md#list) | **GET** {apt_repository_version_href}versions/ | 
*RepositoriesDebVersionsApi* | [**read**](docs/RepositoriesDebVersionsApi.md#read) | **GET** {apt_repository_version_href} | 
*RepositoriesDebVersionsApi* | [**repair**](docs/RepositoriesDebVersionsApi.md#repair) | **POST** {apt_repository_version_href}repair/ | 


## Documentation For Models

 - [AsyncOperationResponse](docs/AsyncOperationResponse.md)
 - [ContentSummary](docs/ContentSummary.md)
 - [ContentSummaryResponse](docs/ContentSummaryResponse.md)
 - [DebAptDistribution](docs/DebAptDistribution.md)
 - [DebAptDistributionResponse](docs/DebAptDistributionResponse.md)
 - [DebAptPublication](docs/DebAptPublication.md)
 - [DebAptPublicationResponse](docs/DebAptPublicationResponse.md)
 - [DebAptRemote](docs/DebAptRemote.md)
 - [DebAptRemoteResponse](docs/DebAptRemoteResponse.md)
 - [DebAptRepository](docs/DebAptRepository.md)
 - [DebAptRepositoryResponse](docs/DebAptRepositoryResponse.md)
 - [DebBasePackage](docs/DebBasePackage.md)
 - [DebBasePackageResponse](docs/DebBasePackageResponse.md)
 - [DebGenericContent](docs/DebGenericContent.md)
 - [DebGenericContentResponse](docs/DebGenericContentResponse.md)
 - [DebInstallerFileIndex](docs/DebInstallerFileIndex.md)
 - [DebInstallerFileIndexResponse](docs/DebInstallerFileIndexResponse.md)
 - [DebPackageIndex](docs/DebPackageIndex.md)
 - [DebPackageIndexResponse](docs/DebPackageIndexResponse.md)
 - [DebPackageReleaseComponent](docs/DebPackageReleaseComponent.md)
 - [DebPackageReleaseComponentResponse](docs/DebPackageReleaseComponentResponse.md)
 - [DebRelease](docs/DebRelease.md)
 - [DebReleaseArchitecture](docs/DebReleaseArchitecture.md)
 - [DebReleaseArchitectureResponse](docs/DebReleaseArchitectureResponse.md)
 - [DebReleaseComponent](docs/DebReleaseComponent.md)
 - [DebReleaseComponentResponse](docs/DebReleaseComponentResponse.md)
 - [DebReleaseFile](docs/DebReleaseFile.md)
 - [DebReleaseFileResponse](docs/DebReleaseFileResponse.md)
 - [DebReleaseResponse](docs/DebReleaseResponse.md)
 - [DebVerbatimPublication](docs/DebVerbatimPublication.md)
 - [DebVerbatimPublicationResponse](docs/DebVerbatimPublicationResponse.md)
 - [InlineResponse200](docs/InlineResponse200.md)
 - [InlineResponse2001](docs/InlineResponse2001.md)
 - [InlineResponse20010](docs/InlineResponse20010.md)
 - [InlineResponse20011](docs/InlineResponse20011.md)
 - [InlineResponse20012](docs/InlineResponse20012.md)
 - [InlineResponse20013](docs/InlineResponse20013.md)
 - [InlineResponse20014](docs/InlineResponse20014.md)
 - [InlineResponse2002](docs/InlineResponse2002.md)
 - [InlineResponse2003](docs/InlineResponse2003.md)
 - [InlineResponse2004](docs/InlineResponse2004.md)
 - [InlineResponse2005](docs/InlineResponse2005.md)
 - [InlineResponse2006](docs/InlineResponse2006.md)
 - [InlineResponse2007](docs/InlineResponse2007.md)
 - [InlineResponse2008](docs/InlineResponse2008.md)
 - [InlineResponse2009](docs/InlineResponse2009.md)
 - [PatcheddebAptDistribution](docs/PatcheddebAptDistribution.md)
 - [PatcheddebAptRemote](docs/PatcheddebAptRemote.md)
 - [PatcheddebAptRepository](docs/PatcheddebAptRepository.md)
 - [PolicyEnum](docs/PolicyEnum.md)
 - [RepositoryAddRemoveContent](docs/RepositoryAddRemoveContent.md)
 - [RepositorySyncURL](docs/RepositorySyncURL.md)
 - [RepositoryVersion](docs/RepositoryVersion.md)
 - [RepositoryVersionResponse](docs/RepositoryVersionResponse.md)


## Documentation For Authorization


## basicAuth

- **Type**: HTTP basic authentication


## cookieAuth

- **Type**: API key
- **API key parameter name**: Session
- **Location**: 


## Author

pulp-list@redhat.com


